/*
   
 * ADM CONFIDENTIAL -- (ADM Confidential Restricted when
 * combined with the aggregated modules for this product)
 * OBJECT CODE ONLY SOURCE MATERIALS
 * (C) COPYRIGHT ADM Crew. 1999
 * All Rights Reserved

 ADMdialout - cisco modems (tcp port 200x) scanner by plaguez (02/99)

 best used with ADMcisco:

 ( ./zone .net ; ./ADMcisco le0 ; ./ADMdialout )
 
*/

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <unistd.h>
#include <netinet/in.h>
#include <limits.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <stdarg.h>
#include <time.h>
#include <sys/time.h>

#include "ADMtelnet.h"

#define APPNAME "ADMdialouts"
#include <debug.h>

#define ASK "AT\r\n"
#define EXPECT "OK"
#define MAXSIZE 1024
/* global timeout (for "ask+expect", not separatly) */
#define TIMEOUT 15000



int ADMtelnet(int);


struct in_addr *atoaddr(char *address) 
{
  	struct hostent *host;
  	static struct in_addr saddr;

  	saddr.s_addr = inet_addr(address);
  	if (saddr.s_addr != -1) 
		return &saddr;
  	host = gethostbyname(address);
  	if (host != NULL)
    		return (struct in_addr *) *host->h_addr_list;
  	return NULL;
}


int tcp_connect(char *host,int port) {
  	struct in_addr *addr;
  	int sock;
  	struct sockaddr_in address;

  	addr = atoaddr(host);
  	if (addr == NULL) 
	{
    		ERROR("can't resolve: %s ",host);
    		return -1;
  	}
   	memset((char *) &address, 0, sizeof(address));
  	address.sin_family = AF_INET;
  	address.sin_port = htons(port);
  	address.sin_addr.s_addr = addr->s_addr;
  	sock = socket(AF_INET, SOCK_STREAM, 0);
      	return((connect(sock, (struct sockaddr *) &address,sizeof(address))<0)?-2:sock);
}


void alarm_handler(int sig)
{
	exit(1);
}

void check(char *host)
{
	int sock,i;
	char buf[MAXSIZE+1];
	
	memset(buf,'\0',MAXSIZE+1);
	for(i=2001;i<2011;i++)
	{
		sock=tcp_connect(host,i);
		if(sock>=0)
			break;
	}

	if(sock<0)
		exit(1);

	signal(SIGALRM,alarm_handler);
	alarm(TIMEOUT);
	ADMtelnet(sock);
	write(sock,ASK,strlen(ASK));
	read(sock,buf,MAXSIZE);
	alarm(0);
	if(strstr(buf,EXPECT))
		fprintf(stderr,"\nFOUND DIALUP host: %s port: %i !\n",host,i);
	exit(0);		
}	


int main()
{
	char buf[MAXSIZE+1];
	
	fprintf(stderr,"\nADMdialout by plaguez - reading from stdin\n\n");
	memset(buf,'\0',MAXSIZE+1);
	while(fgets(buf,MAXSIZE,stdin))
//		if(!fork())
			check(buf);
	return(0);
}
