

int
read_timeout (int s, char *data, int sizeofdata, int timeout)
{
  fd_set fdsetz;
  struct timeval tv;
  int nd;


  tv.tv_sec = timeout;
  tv.tv_usec = 0;

  FD_ZERO (&fdsetz);

  FD_SET (s, &fdsetz);

  nd = select (FD_SETSIZE, &fdsetz, NULL, NULL, &tv);
  if (nd <= 0)
    {

      return (-2);
    }


  if (FD_ISSET (s, &fdsetz))
    return (read (s, data, sizeofdata));

  return (-2);
}


unsigned long
host2ip (char *serv)
{
  struct sockaddr_in sinn;
  struct hostent *hent;

  hent = gethostbyname (serv);
  if (hent == NULL)
    return 0;
  bzero ((char *) &sinn, sizeof (sinn));
  memcpy ((char *) &sinn.sin_addr, hent->h_addr, hent->h_length);
  return sinn.sin_addr.s_addr;
}


/*  make a telnet connection */

int
ADMtelnet (u_long ip, int port,u_short sportz)
{
  struct sockaddr_in sin;
  u_char buf[3];


  int dasock;
  int longueur = sizeof (struct sockaddr_in);
  int i = 0, r = 0;
  dasock = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);	/* gimme a socket */
  if (dasock < 0)
    return (-1);
 
 i = 1;
 
if  ( setsockopt (dasock,SOL_SOCKET,SO_REUSEADDR,&i,sizeof(i)) < 0)
   printf ("setsockopt error :/\n");
 i = 0;
  
  
if ( sportz != 0 ) 
 {
   sin.sin_family = AF_INET;
   sin.sin_port = htons (sportz);
   sin.sin_addr.s_addr = INADDR_ANY;
   
  if ( bind (dasock,(struct sockaddr *)&sin,longueur) < 0 ) 
    {
     printf ("cant bind socket :/\n");
     return (-1);
    }
 }
 
  sin.sin_family = AF_INET;
  sin.sin_port = htons (port);
  sin.sin_addr.s_addr = ip;
        
  if (connect (dasock, (struct sockaddr *) &sin, longueur) < 0)
    {
      close (dasock);
      return (-1);
    }

  while (1)
    {
      memset (buf, 0, sizeof (buf));
      r = 0;
      r = read_timeout (dasock, buf, 1, 5);

      if (r == -2)
	{
	  printf ("\n<*> admtelnet () timeout :)\n<*> maybe the negoc is over!\n");
	  return (dasock);
	}
      if (r == -1)
	{
	  perror ("read");
	  close (dasock);
	  return (-1);
	}

      if (*buf == (unsigned int) 255)
	{
	  r = read_timeout (dasock, (buf + 1), 2, 3);

	  if (r == -2)
	    {
	      printf ("\n<*> admtelnet () timeout :)\n<*> maybe the negoc is over!\n");
	      return (dasock);
	    }
	  if (r == -1)
	    {
	      perror ("read");
	      close (dasock);
	      return (-1);
	    }

	  if (buf[1] == 253 || buf[1] == 251 || buf[1] == 254)
	    {
	      if (buf[1] == 251)
		buf[1] = 254;
	      else
		buf[1] = 252;
	      if (write (dasock, buf, 3) < 0)
		{
		  close (dasock);
		  return (-1);
		}

	      continue;
	    }

	}
      else
	{
	  return (dasock);
	}


    }

  close (dasock);
  return -1;
}


int
waitfor (char **str, int timeout, char *bufr)
{
  int i;
  char c;
  char buffer[8012];
  struct timeval tv, tv2;
  gettimeofday (&tv, NULL);
  tv.tv_sec = (tv.tv_sec + timeout);

  memset (buffer, 0, sizeof (buffer));
 
  while (1)
    {
      c = 0;
      read_timeout (fs, &c, 1, 1);
      gettimeofday (&tv2, NULL);

      if (tv2.tv_sec > tv.tv_sec)
	{
//	  printf ("\n<*> waitfor() timeout!\n");
	  return (-1);
	}

      if (c != 0)
	{
	  putchar ((int) c);
	  fflush (stdout);
	}

      if (c == '\r')
	memset (buffer, 0, sizeof (buffer));
      if (c == '\n')
	memset (buffer, 0, sizeof (buffer));

      if (strlen (buffer) < sizeof (buffer) - 2)
	{
	  strncat (buffer, &c, 1);
	}

      for (i = 0; str[i] != NULL; i++)
	if (strstr (buffer, str[i]))
	  {
	
	    if (bufr == NULL)
	      return (1);
	    else
	      strncpy (bufr, buffer,8011);
	    return (1);
	  }

    }
return (-1);
}

char *
readflow (int timeout)
{
  char c;
  static char buffer[8012];
  struct timeval tv, tv2;

  gettimeofday (&tv, NULL);
  tv.tv_sec = (tv.tv_sec + timeout);

  memset (buffer, 0, sizeof (buffer));
  while (1)
    {
      c = 0;
      read_timeout (fs, &c, 1, 1);
      gettimeofday (&tv2, NULL);

      if (tv2.tv_sec > tv.tv_sec)
	{
	  printf ("\n<*> readflow done!\n");
	  return ((char *) &buffer);
	}

      if (c != 0)
	{
	  putchar ((int) c);
	  fflush (stdout);
	}

      if (strlen (buffer) < sizeof (buffer) - 2)
	{
	  strncat (buffer, &c, 1);
	}

    }
}

int
allocstr (char **strtab, char *str)
{
  int i;
  for (i = 0; i < 255; i++)
    {
      if (strtab[i] == NULL)
	{
	  strtab[i] = calloc (1, strlen (str) + 1);
	  if (strtab[i] == NULL)
	    return (-1);
	  strcpy (strtab[i], str);
	  return (1);
	}
    }
  return (-1);
}

void
freeall (char **strtab)
{
  int i;
  for (i = 0; i < 255; i++)
    if (strtab[i] != NULL)
      {
	free (strtab[i]);
	strtab[i] = NULL;
      }
}
